<?php
use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfLCRFaultInfoType ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfLCRFaultInfoType
 * @subpackage Arrays
 */
class ArrayOfLCRFaultInfoType extends AbstractStructArrayBase
{
    /**
     * The LCRFaultInfoType
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var LCRFaultInfoType[]
     */
    public $LCRFaultInfoType;
    /**
     * Constructor method for ArrayOfLCRFaultInfoType
     * @uses ArrayOfLCRFaultInfoType::setLCRFaultInfoType()
     * @param LCRFaultInfoType[] $lCRFaultInfoType
     */
    public function __construct(array $lCRFaultInfoType = array())
    {
        $this
            ->setLCRFaultInfoType($lCRFaultInfoType);
    }
    /**
     * Get LCRFaultInfoType value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return LCRFaultInfoType[]|null
     */
    public function getLCRFaultInfoType()
    {
        return isset($this->LCRFaultInfoType) ? $this->LCRFaultInfoType : null;
    }
    /**
     * This method is responsible for validating the values passed to the setLCRFaultInfoType method
     * This method is willingly generated in order to preserve the one-line inline validation within the setLCRFaultInfoType method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateLCRFaultInfoTypeForArrayConstraintsFromSetLCRFaultInfoType(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfLCRFaultInfoTypeLCRFaultInfoTypeItem) {
            // validation for constraint: itemType
            if (!$arrayOfLCRFaultInfoTypeLCRFaultInfoTypeItem instanceof LCRFaultInfoType) {
                $invalidValues[] = is_object($arrayOfLCRFaultInfoTypeLCRFaultInfoTypeItem) ? get_class($arrayOfLCRFaultInfoTypeLCRFaultInfoTypeItem) : sprintf('%s(%s)', gettype($arrayOfLCRFaultInfoTypeLCRFaultInfoTypeItem), var_export($arrayOfLCRFaultInfoTypeLCRFaultInfoTypeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The LCRFaultInfoType property can only contain items of type LCRFaultInfoType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set LCRFaultInfoType value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param LCRFaultInfoType[] $lCRFaultInfoType
     * @return ArrayOfLCRFaultInfoType
     */
    public function setLCRFaultInfoType(array $lCRFaultInfoType = array())
    {
        // validation for constraint: array
        if ('' !== ($lCRFaultInfoTypeArrayErrorMessage = self::validateLCRFaultInfoTypeForArrayConstraintsFromSetLCRFaultInfoType($lCRFaultInfoType))) {
            throw new \InvalidArgumentException($lCRFaultInfoTypeArrayErrorMessage, __LINE__);
        }
        if (is_null($lCRFaultInfoType) || (is_array($lCRFaultInfoType) && empty($lCRFaultInfoType))) {
            unset($this->LCRFaultInfoType);
        } else {
            $this->LCRFaultInfoType = $lCRFaultInfoType;
        }
        return $this;
    }
    /**
     * Add item to LCRFaultInfoType value
     * @throws \InvalidArgumentException
     * @param LCRFaultInfoType $item
     * @return ArrayOfLCRFaultInfoType
     */
    public function addToLCRFaultInfoType(LCRFaultInfoType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof LCRFaultInfoType) {
            throw new \InvalidArgumentException(sprintf('The LCRFaultInfoType property can only contain items of type LCRFaultInfoType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->LCRFaultInfoType[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return LCRFaultInfoType|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return LCRFaultInfoType|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return LCRFaultInfoType|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return LCRFaultInfoType|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return LCRFaultInfoType|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string LCRFaultInfoType
     */
    public function getAttributeName()
    {
        return 'LCRFaultInfoType';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return ArrayOfLCRFaultInfoType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
